//
//  TVSettingsTweakViewController.m
//  nitoTV4
//
//  Created by Kevin Bradley on 7/28/18.
//  Copyright © 2018 nito. All rights reserved.
//

#import "TVSettingsTweakViewController.h"

@implementation TVSettingsTweakViewController


- (id)loadSettingGroups {
    
    NSMutableArray *_backingArray = [NSMutableArray new];
    Class theClass = NSClassFromString(@"DDBSettingsController");
    TSKSettingItem *testItem = [TSKSettingItem childPaneItemWithTitle:@"Dales Dead Bug" description:@"You just be careful, Computers have already beaten the Communists at chess. Next thing you know, they'll be beating humans. - Dale Gribble" representedObject:nil keyPath:nil childControllerClass:theClass];
    TSKSettingGroup *group = [TSKSettingGroup groupWithTitle:nil settingItems:@[testItem]];
    [_backingArray addObject:group];
    [self setValue:_backingArray forKey:@"_settingGroups"];
    
    return _backingArray;
    
}

@end

@interface DDBSettingsController: TSKViewController

@end

@implementation DDBSettingsController

- (id)loadSettingGroups {
    
    /*
     
     +[<TSKSettingItem: 0x1ad71bc88> toggleItemWithTitle:Automatically Update Apps description:(null) representedObject:<TVSettingsPreferenceFacade: 0x1c0438480> keyPath:AutoUpdatesEnabled onTitle:(null) offTitle:(null)]
     */
    
    id facade = [[ NSClassFromString(@"TVSettingsPreferenceFacade") alloc] initWithDomain:@"com.nito.dalesdeadbug" notifyChanges:TRUE];
    
    
    NSMutableArray *_backingArray = [NSMutableArray new];
    Class theClass = NSClassFromString(@"TVSettingsGeneralViewController");
    TSKSettingItem *toggleItem = [TSKSettingItem toggleItemWithTitle:@"Spoof version" description:@"Enables you to install newer application versions that would normally not be supported on your current tvOS version." representedObject:facade keyPath:@"Enabled" onTitle:nil offTitle:nil];
    //TSKSettingItem *textEntryItem = [TSKSettingItem textInputItemWithTitle:@"Tests text entry" description:@"This is a test" representedObject:facade keyPath:@"textTest"];
    /*
     
     multiValueItemWithTitle:Apple TV Name description:You can name your Apple TV to make it easy to recognize when you use AirPlay and Home Sharing. representedObject:<TVSettingsDeviceFacade: 0x1c087e2c0> keyPath:name availableValues:(
     "Apple TV",
     "Living Room",
     "Family Room",
     Bedroom,
     Kitchen,
     "Great Room",
     Office
     )]

     
     */
    
    
    

    TSKSettingItem *multiItem = [TSKSettingItem multiValueItemWithTitle:@"Test" description:@"Science" representedObject:facade keyPath:@"SpoofVersion" availableValues:@[@"11.1", @"11.2", @"11.3", @"11.4"]];
    TSKSettingGroup *group = [TSKSettingGroup groupWithTitle:nil settingItems:@[toggleItem, multiItem]];
    [_backingArray addObject:group];
    [self setValue:_backingArray forKey:@"_settingGroups"];
    
    return _backingArray;
    
}

@end
